/**
 * 
 */
package com.hengtian.simplechat;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * @author notifier
 * @create 2010-9-25 07:06:54
 * @version 1.0
 */
public class SimpleChatServer
{
	// ͻб
	private ArrayList clientList = new ArrayList();;
	
	public static void main(String[] args)
	{
		new SimpleChatServer().startUp();
	}
	
	/**
	 * ˵
	 *
	 */
	public void startUp()
	{
		try
		{
			// ServerSocket,˿ں5000
			ServerSocket serverSocket = new ServerSocket(5000);
			
			// ѯȴͻ
			while(true)
			{
				// ȴͻ,;ʱ,һԸsocket
				Socket clientSocket = serverSocket.accept();
				
				// ÿͻ˼뵽б
				PrintWriter writer = new PrintWriter(clientSocket.getOutputStream());
				clientList.add(writer);
				
				// ClientHandler,ͨsocketͨ
				Thread t = new Thread(new ClientHandler(clientSocket));
				t.start();

				System.out.println("Client");
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	/**
	 * ͻ˴, Ҫ:
	 * 1.տͻ˷Ϣ
	 * 2.Ϣתͻ
	 * @author sdniu
	 * @create 2010-9-26 10:00:18
	 * @version 1.0
	 */
	public class ClientHandler implements Runnable
	{
		private BufferedReader reader;
		private Socket socket;
		
		/**
		 * ClientHandlerĹ캯
		 * @param clientSocket
		 */
		public ClientHandler(Socket clientSocket)
		{
			
			try
			{
				// õsocket
				socket = clientSocket;
				
				// õͻ˷Ϣ
				InputStreamReader isReader = new InputStreamReader(socket.getInputStream());
				reader = new BufferedReader(isReader);
			} catch (IOException e)
			{
				e.printStackTrace();
			}
		}
		
		public void run()
		{
			String message;
			try
			{
				while((message = reader.readLine()) != null)
				{
					System.out.println("ͻϢ: " + message);
					// ͻ˷Ϣתпͻ
					notifyAllClients(message);
				}
			} catch (IOException e)
			{
				e.printStackTrace();
			}
		}
	}
	
	/**
	 * 
	 * @param message
	 */
	public void notifyAllClients(String message)
	{
		// õͻбĵ,﷨ʽΪ Iterator it = clientList.iterator();
		Iterator it = clientList.iterator();
		
		while(it.hasNext())
		{
			try
			{
				// õIteratorǿתPrintWriter
				PrintWriter writer = (PrintWriter) it.next();
				writer.println(message);
				writer.flush();
			} catch (Exception e)
			{
				e.printStackTrace();
			}			
		}
	}
}
